﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Documents;
using Telerik.Windows.Documents.Model;
using Telerik.Windows.Documents.Selection;

namespace ClassLibrary
{
    public class CustomControl : RadRichTextBox
    {
        DocumentPosition startPositionMemory;
        DocumentPosition stopPositionMemory;
        PointF positionMemory;

        public CustomControl()
        {
            this.DefaultStyleKey = typeof(RadRichTextBox);
            //this.MouseLeave += new MouseEventHandler(CustomControl_MouseLeave);
            //this.CommandExecuting += new EventHandler<Telerik.Windows.Documents.RichTextBoxCommands.CommandExecutingEventArgs>(CustomControl_CommandExecuting);
        }

        void CustomControl_MouseLeave(object sender, MouseEventArgs e)
        {
            if ((SelectionRange)this.Document.Selection.Ranges.First != null)
            {
                startPositionMemory = ((SelectionRange)this.Document.Selection.Ranges.First).StartPosition;
                stopPositionMemory = ((SelectionRange)this.Document.Selection.Ranges.First).EndPosition;
                positionMemory = this.Document.Selection.Ranges.First.StartPosition.Location;
            }
        }

        void CustomControl_CommandExecuting(object sender, Telerik.Windows.Documents.RichTextBoxCommands.CommandExecutingEventArgs e)
        {
            if (this.Document.Selection.Ranges.Count == 0 && startPositionMemory != null && stopPositionMemory != null)
            {
                this.Document.CaretPosition.SetPosition(positionMemory);
                this.Document.Selection.SetSelectionStart(startPositionMemory);
                this.Document.Selection.AddSelectionEnd(stopPositionMemory);
            }
        }
    }
}
